freeslot("S_PLAY_ACECROUCH", "S_PLAY_ACECRAWL", "S_PLAY_ACESLIDE", "S_PLAY_ACESLIDE_JUMP", "S_PLAY_ACEDIVE", "S_PLAY_ACEDIVE_UNDIVE",

"S_PLAY_ACEBOULDERLIFT", "S_PLAY_ACEBUBBLEJUMP", "S_PLAY_ACECLOUDSURF", "S_PLAY_ACEFLAMEDASH",

"SPR2_CRCH", "SPR2_CRWL", "SPR2_FCRH", "SPR2_FCRL",
"SPR2_FWLK", "SPR2_FRUN", "SPR2_FSKD", "SPR2_FJMP",
"SPR2_FAIR", "SPR2_FRID", "SPR2_FFLY", "SPR2_FGLD",
"SPR2_FCNG", "SPR2_FSWM", "SPR2_SLID", "SPR2_SLDJ",
"SPR2_DIVE", //"SPR2_WRUN", -- Wall Run has been scraped.
"SPR2_BOLD", "SPR2_BUBJ", "SPR2_GRND", "SPR2_FMDH",

"MT_ACERAY",

"MT_ACEEARTH", "S_ACEEARTH", "S_ACEEARTH_CRUMBLE", "SPR_AWAR", "MT_ACEWATER", "S_ACEWATER", "S_ACEWATER_SPLASH",
"MT_ACEAIR", "S_ACEAIR", "S_ACEAIR_FADE", "MT_ACEFIRE", "S_ACEFIRE", "S_ACEFIRE_EXTINGUISH",

"MT_ACEBOULDER", "S_ACEBOULDER", "S_ACEBOULDER_CRUMBLE", "MT_ACEBUBBLE", "S_ACEBUBBLE", "S_ACEBUBBLE_POP",
"MT_ACECLOUD", "S_ACECLOUD", "S_ACECLOUD_POOF", "SPR_ACLD", "MT_ACEFIREBALL", "S_ACEFIREBALL", "S_ACEFIREBALL_EXTINGUISH", "MT_FLAMETRAIL", "S_FLAMETRAIL",

"MT_ACETORNADO", "S_ACETORNADO", "S_ACETORNADO_FADE", "MT_ACETORNADO", "S_ACETORNADO", "S_ACETORNADO_FADE") -- For Battle/Persona

-- Player States

states[S_PLAY_ACESLIDE] = {SPR_PLAY, SPR2_SLID, 8, nil, 0, 0, S_PLAY_WALK}
states[S_PLAY_ACESLIDE_JUMP] = {SPR_PLAY, SPR2_SLDJ|FF_ANIMATE, 24, nil, 7, 3, S_PLAY_FALL}

states[S_PLAY_ACEDIVE] = {SPR_PLAY, SPR2_DIVE, 8, nil, 0, 0, S_PLAY_FALL}
states[S_PLAY_ACEDIVE_UNDIVE] = {SPR_PLAY, SPR2_ROLL|FF_ANIMATE, 8, nil, 3, 2, S_PLAY_FALL}

states[S_PLAY_ACEBOULDERLIFT] = {SPR_PLAY, SPR2_BOLD, 4, nil, 0, 0, S_PLAY_JUMP}
states[S_PLAY_ACEBUBBLEJUMP] = {SPR_PLAY, SPR2_BUBJ, 4, nil, 0, 0, S_PLAY_FALL}
states[S_PLAY_ACECLOUDSURF] = {SPR_PLAY, SPR2_GRND, 4, nil, 0, 0, S_PLAY_FALL}
states[S_PLAY_ACEFLAMEDASH] = {SPR_PLAY, SPR2_FMDH, 4, nil, 0, 0, S_PLAY_FALL}

mobjinfo[MT_ACERAY] =
{
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 16*FRACUNIT,
	height = 16*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT
}

-- Elemental Projectiles

mobjinfo[MT_ACEEARTH] =
{
	doomednum = -1,
	spawnstate = S_ACEEARTH,
	deathstate = S_ACEEARTH_CRUMBLE,
	seesound = sfx_s3k49,
	deathsound = sfx_s3k59,
	activesound = sfx_rocks1,
	spawnhealth = 10,
	reactiontime = 1,
	painchance = 10*FRACUNIT,
	speed = 30*FRACUNIT,
	radius = 16*FRACUNIT,
	height = 24*FRACUNIT,
	damage = 1,
	flags = MF_NOBLOCKMAP|MF_SLIDEME|MF_MISSILE|MF_BOUNCE|MF_GRENADEBOUNCE
}
states[S_ACEEARTH] = {SPR_ROIB, FF_ANIMATE|A, 20, nil, 7, 2, S_ACEEARTH_CRUMBLE}
states[S_ACEEARTH_CRUMBLE] = {SPR_ROIB, 0, 0, nil, 0, 0, S_NULL}

mobjinfo[MT_ACEWATER] =
{
	doomednum = -1,
	spawnstate = S_ACEWATER,
	deathstate = S_ACEWATER_SPLASH,
	//seesound = sfx_splish,
	deathsound = sfx_splish,
	spawnhealth = 10,
	reactiontime = 1,
	painchance = FRACUNIT,
	speed = 30*FRACUNIT,
	radius = 16*FRACUNIT,
	height = 24*FRACUNIT,
	mass = DMG_WATER,
	damage = 1,
	flags = MF_NOBLOCKMAP|MF_BOUNCE|MF_GRENADEBOUNCE
}
states[S_ACEWATER] = {SPR_AWAR, FF_TRANS20|A, 10, nil, 0, 0, S_ACEWATER_SPLASH}
states[S_ACEWATER_SPLASH] = {SPR_AWAR, 0, 0, nil, 0, 0, S_NULL}

mobjinfo[MT_ACEAIR] =
{
	doomednum = -1,
	spawnstate = S_ACEAIR,
	deathstate = S_ACEAIR_FADE,
	//seesound = sfx_s3kces,
	deathsound = sfx_s3kces,
	spawnhealth = 10,
	reactiontime = 1,
	painchance = FRACUNIT,
	speed = 30*FRACUNIT,
	radius = 16*FRACUNIT,
	height = 24*FRACUNIT,
	damage = 1,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_FLOAT|MF_BOUNCE|MF_GRENADEBOUNCE
}
states[S_ACEAIR] = {SPR_BOM1, FF_ANIMATE|FF_TRANS20|C, 10, nil, 3, 4, S_ACEAIR_FADE}
states[S_ACEAIR_FADE] = {SPR_BOM1, 0, 0, nil, 0, 0, S_NULL}

mobjinfo[MT_ACEFIRE] =
{
	doomednum = -1,
	spawnstate = S_ACEFIRE,
	deathstate = S_ACEFIRE_EXTINGUISH,
	//seesound = sfx_fire,
	deathsound = sfx_steam1,
	spawnhealth = 10,
	reactiontime = 1,
	painchance = FRACUNIT,
	speed = 30*FRACUNIT,
	radius = 16*FRACUNIT,
	height = 24*FRACUNIT,
	mass = DMG_FIRE,
	damage = 1,
	flags = MF_NOBLOCKMAP|MF_MISSILE|MF_NOGRAVITY|MF_FLOAT|MF_BOUNCE|MF_GRENADEBOUNCE|MF_FIRE
}
states[S_ACEFIRE] = {SPR_FLME, FF_ANIMATE|FF_FULLBRIGHT|FF_TRANS20|A, 10, nil, 2, 4, S_ACEFIRE_EXTINGUISH}
states[S_ACEFIRE_EXTINGUISH] = {SPR_FLME, 0, 0, nil, 0, 0, S_NULL}

-- Element Jump Ability Objects

mobjinfo[MT_ACEBOULDER] =
{
	doomednum = -1,
	spawnstate = S_ACEBOULDER,
	deathstate = S_ACEBOULDER_CRUMBLE,
	seesound = sfx_s3k49,
	deathsound = sfx_s3k59,
	activesound = sfx_rocks1,
	spawnhealth = 10,
	reactiontime = 1,
	painchance = 10*FRACUNIT,
	radius = 16*FRACUNIT,
	height = 24*FRACUNIT,
	dispoffset = 1,
	damage = 1,
	flags = MF_NOBLOCKMAP|MF_SOLID|MF_SLIDEME
}
states[S_ACEBOULDER] = {SPR_ROIB, A, -1, nil, 0, 0, S_ACEBOULDER_CRUMBLE}
states[S_ACEBOULDER_CRUMBLE] = {SPR_ROIB, 0, 0, nil, 0, 0, S_NULL}

mobjinfo[MT_ACEBUBBLE] =
{
	doomednum = -1,
	spawnstate = S_ACEBUBBLE,
	deathstate = S_ACEBUBBLE_POP,
	seesound = sfx_splash,
	deathsound = sfx_s3k77,
	spawnhealth = 100,
	radius = 40*FRACUNIT,
	height = 40*FRACUNIT,
	dispoffset = 1,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_FLOAT
}
states[S_ACEBUBBLE] = {SPR_BUBS, K, -1, nil, 0, 0}
states[S_ACEBUBBLE_POP] = {SPR_BUBS, 0, 0, nil, 0, 0, S_NULL}

mobjinfo[MT_ACECLOUD] =
{
	doomednum = -1,
	spawnstate = S_ACECLOUD,
	deathstate = S_ACECLOUD_POOF,
	seesound = sfx_wdjump,
	deathsound = sfx_wdjump,
	spawnhealth = 100,
	radius = 16*FRACUNIT,
	height = 24*FRACUNIT,
	dispoffset = -1,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_FLOAT
}
states[S_ACECLOUD] = {SPR_ACLD, A, -1, nil, 0, 0}
states[S_ACECLOUD_POOF] = {SPR_ACLD, 0, 0, nil, 0, 0, S_NULL}

mobjinfo[MT_ACEFIREBALL] =
{
	doomednum = -1,
	spawnstate = S_ACEFIREBALL,
	deathstate = S_ACEFIREBALL_EXTINGUISH,
	seesound = sfx_s1b3,
	deathsound = sfx_s1ae,
	spawnhealth = 100,
	radius = 40*FRACUNIT,
	height = 40*FRACUNIT,
	dispoffset = 1,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_FLOAT|MF_FIRE
}
states[S_ACEFIREBALL] = {SPR_FIRS, FF_FULLBRIGHT|FF_TRANS50|S, -1, nil, 0, 0}
states[S_ACEFIREBALL_EXTINGUISH] = {SPR_FIRS, 0, 0, nil, 0, 0, S_NULL}